#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int p[20];
int l[20];

int log(int n, int base)
{
    int r = 0;
    long long t = 1;
    while(t<=n) {
        r++;
        t *= base;
    }

    return r;
}

int n;
int x,y;
vector<int> vec;

void gen(int i, long long val)
{
    if(i==n) {
        if(val >=x && val <= y)
            vec.push_back(val);
    }

    for(int j=0; j<l[i] && val<=y; ++j) {
        gen(i+1, val);
        val *= p[i];
    }
}

int main()
{

    while(cin>>n, n) {
        for(int i=0; i<n; ++i)
            cin >> p[i];

        cin >> x >> y;

        for(int i=0; i<n; ++i)
            l[i] = log(y, p[i]);

        vec.clear();
        gen(0, 1);

        sort(vec.begin(), vec.end());

        if(vec.size()==0)
            cout << "none\n";
        else {
            cout << vec[0];
            for(size_t i=1; i<vec.size(); ++i)
                cout << "," << vec[i];
            cout << endl;
        }
    }

    return 0;
}
